﻿// CodeGear C++Builder
// Copyright (c) 1995, 2016 by Embarcadero Technologies, Inc.
// All rights reserved

// (DO NOT EDIT: machine generated header) 'FlexPath.pas' rev: 32.00 (Windows)

#ifndef FlexpathHPP
#define FlexpathHPP

#pragma delphiheader begin
#pragma option push
#pragma option -w-      // All warnings off
#pragma option -Vx      // Zero-length empty class member 
#pragma pack(push,8)
#include <System.hpp>
#include <SysInit.hpp>
#include <Winapi.Windows.hpp>
#include <System.Classes.hpp>
#include <FlexUtils.hpp>
#include <System.Types.hpp>

//-- user supplied -----------------------------------------------------------

namespace Flexpath
{
//-- forward type declarations -----------------------------------------------
struct TPathEditParams;
struct TNearestPoint;
struct TPathFigureInfo;
struct TPathInfo;
struct TRerouteParams;
//-- type declarations -------------------------------------------------------
enum DECLSPEC_DENUM TPointType : unsigned char { ptNode, ptEndNode, ptEndNodeClose, ptControl };

typedef System::DynamicArray<System::Types::TPoint> TPointArray;

typedef System::DynamicArray<TPointType> TPointTypeArray;

typedef System::DynamicArray<bool> TSelectedArray;

typedef System::DynamicArray<System::Types::TRect> TRectArray;

enum DECLSPEC_DENUM TPathEditFunc : unsigned char { pfOffset, pfJoin, pfBreak, pfClose, pfToLine, pfToCurve };

typedef System::Set<TPathEditFunc, TPathEditFunc::pfOffset, TPathEditFunc::pfToCurve> TPathEditFuncs;

typedef TPathEditParams *PPathEditParams;

struct DECLSPEC_DRECORD TPathEditParams
{
public:
	System::Types::TPoint Offset;
	bool MoveControls;
};


typedef TNearestPoint *PNearestPoint;

struct DECLSPEC_DRECORD TNearestPoint
{
public:
	System::Types::TPoint Point;
	int Index0;
	int Index1;
	int MinIndex;
	float MinSqrDist;
	float CurvePos;
	bool IsNewMin;
};


typedef TPathFigureInfo *PPathFigureInfo;

struct DECLSPEC_DRECORD TPathFigureInfo
{
public:
	int FirstNode;
	int LastNode;
	int LastPoint;
	bool IsClosed;
	bool IsCurve;
};


typedef System::DynamicArray<TPathFigureInfo> TPathFigureInfos;

typedef TPathInfo *PPathInfo;

struct DECLSPEC_DRECORD TPathInfo
{
public:
	int PointCount;
	bool IsCurve;
	TPathFigureInfos Figures;
};


enum DECLSPEC_DENUM TRerouteMode : unsigned char { rmAlways, rmAsNeeded, rmNever };

typedef TRerouteParams *PRerouteParams;

struct DECLSPEC_DRECORD TRerouteParams
{
public:
	System::Types::TRect RangeA;
	System::Types::TRect RangeB;
	TRerouteMode Mode;
	bool Ortogonal;
	int LinkMinGap;
	bool SelfLink;
	System::Types::TPoint LinkPointA;
	System::Types::TPoint LinkPointB;
};


//-- var, const, procedure ---------------------------------------------------
extern DELPHI_PACKAGE bool __fastcall PointOnLine(const System::Types::TPoint &p, const System::Types::TPoint &p0, const System::Types::TPoint &p1, int StrokeWidth, System::Classes::TList* ScanLinePoints = (System::Classes::TList*)(0x0), PNearestPoint Nearest = (PNearestPoint)(0x0));
extern DELPHI_PACKAGE bool __fastcall CalcPath(const TPointArray Points, const TPointTypeArray Types, System::Types::TRect &Range, PPathInfo Info = (PPathInfo)(0x0));
extern DELPHI_PACKAGE bool __fastcall CreatePath(HDC DC, const TPointArray Points, const TPointTypeArray Types, bool UseClosed, bool UseNotClosed, bool &Complete, bool OriginalBezier = false, PPathInfo Info = (PPathInfo)(0x0));
extern DELPHI_PACKAGE bool __fastcall PointOnPath(const TPointArray Points, const TPointTypeArray Types, const System::Types::TPoint &Point, bool Stroked, bool Filled, int StrokeWidth = 0x0, PNearestPoint Nearest = (PNearestPoint)(0x0), PPathInfo Info = (PPathInfo)(0x0), Winapi::Windows::PSingle LengthPos = (Winapi::Windows::PSingle)(0x0));
extern DELPHI_PACKAGE float __fastcall PathLength(const TPointArray Points, const TPointTypeArray Types, PPathInfo Info = (PPathInfo)(0x0));
extern DELPHI_PACKAGE bool __fastcall PathLengthPos(const TPointArray Points, const TPointTypeArray Types, float PathPos, PNearestPoint Nearest, PPathInfo Info = (PPathInfo)(0x0));
extern DELPHI_PACKAGE bool __fastcall FlattenPath(TPointArray &Points, TPointTypeArray &Types, float Curvature, PPathInfo Info = (PPathInfo)(0x0));
extern DELPHI_PACKAGE int __fastcall InsertPathPoint(TPointArray &Points, TPointTypeArray &Types, int FirstIndex, int NextIndex, const System::Types::TPoint &Point, int StickThreshold = 0x0, PPathInfo Info = (PPathInfo)(0x0));
extern DELPHI_PACKAGE bool __fastcall FindNearestPathSegment(const TPointArray Points, const TPointTypeArray Types, const System::Types::TPoint &Point, int &FirstIndex, int &NextIndex, PNearestPoint Nearest = (PNearestPoint)(0x0), PPathInfo Info = (PPathInfo)(0x0), bool ForInsert = true);
extern DELPHI_PACKAGE int __fastcall InsertNearestPoint(TPointArray &Points, TPointTypeArray &Types, const System::Types::TPoint &Point, int StickThreshold = 0x0, PPathInfo Info = (PPathInfo)(0x0));
extern DELPHI_PACKAGE TPathEditFuncs __fastcall GetEditPathCaps(const TPointArray Points, const TPointTypeArray Types, const TSelectedArray Selected);
extern DELPHI_PACKAGE bool __fastcall EditPath(TPointArray &Points, TPointTypeArray &Types, const TSelectedArray Selected, TPathEditFunc Func, PPathEditParams Params = (PPathEditParams)(0x0))/* overload */;
extern DELPHI_PACKAGE bool __fastcall EditPath(TPointArray &Points, TPointTypeArray &Types, const int *Indexes, const int Indexes_High, TPathEditFunc Func, PPathEditParams Params = (PPathEditParams)(0x0))/* overload */;
extern DELPHI_PACKAGE bool __fastcall ConnectorReroute(TPointArray &Points, TPointTypeArray &PointTypes, const TRerouteParams &Params);
extern DELPHI_PACKAGE void __fastcall GetPathInfo(const TPointArray Points, const TPointTypeArray Types, TPathInfo &Info);
extern DELPHI_PACKAGE int __fastcall GetFigureIndex(const TPathInfo &Info, int PointIndex);
extern DELPHI_PACKAGE bool __fastcall ChangePathCount(TPointArray &Points, TPointTypeArray &Types, int Index, int Delta);
}	/* namespace Flexpath */
#if !defined(DELPHIHEADER_NO_IMPLICIT_NAMESPACE_USE) && !defined(NO_USING_NAMESPACE_FLEXPATH)
using namespace Flexpath;
#endif
#pragma pack(pop)
#pragma option pop

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// FlexpathHPP
